﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Hierchical.Helpers;
using Hierchical.Model;

namespace Hierchical
{

    public class MainWindowViewModel : INotifyPropertyChanged
    {
        public MainWindowViewModel()
        {
            var emp1 = new Employee(1, "John", EmployeType.Academic);
            var emp2 = new Employee(2, "James", EmployeType.Academic);
            var emp3 = new Employee(3, "Jane", EmployeType.Admin);
            var emp4 = new Employee(4, "Kate", EmployeType.Academic);
            var emp5 = new Employee(5, "Paul", EmployeType.Admin);

            Employees = new ObservableCollection<Employee>();
            Employees.Add(emp1);
            emp1.Subordinates.Add(emp2);
            emp1.Subordinates.Add(emp3);
            emp2.Subordinates.Add(emp4);
            emp3.Subordinates.Add(emp5);

        }

        ObservableCollection<Employee> _employees;
        public ObservableCollection<Employee> Employees
        {
            get { return _employees; }
            set
            {
                _employees = value;
                OnPropertyChanged("Employees");
            }
        }

        private Employee _selectedEmployee;

        public Employee SelectedEmployee
        {
            get { return _selectedEmployee; }
            set
            {
                _selectedEmployee = value;
                OnPropertyChanged("SelectedEmployee");
                AddEmployeeCommand.UpdateCanExecuteState();
            }
        }

        private IRelayCommand _addEmployeeCommand;
        public IRelayCommand AddEmployeeCommand
        {
            get { return _addEmployeeCommand ?? (_addEmployeeCommand = new RelayCommand(AddEmployee, CanAddEmployeeCommandExecute)); }
        }

        private bool CanAddEmployeeCommandExecute(object o)
        {
            return SelectedEmployee != null;
        }

        private void AddEmployee(object obj)
        {
            SelectedEmployee.Subordinates.Add(new Employee(Employees.Count + 1, "Name", EmployeType.Academic));
        }

        #region INotifyPropertyChanged

        #endregion
        public event PropertyChangedEventHandler PropertyChanged;
        void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
