﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hierchical.Model
{
    public class Employee : INotifyPropertyChanged
    {
        public Employee(int id, string name, EmployeType empType )
        {
            Id = id;
            EmpType = empType;
            Name = name;
            Subordinates = new ObservableCollection<Employee>();
        }

        int _id;
        public int Id
        {
            get { return _id; }
            set
            {
                _id = value;
                OnPropertyChanged("Id");
            }
        }

        string _name;
        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                OnPropertyChanged("Name");
            }
        }

        EmployeType _empType;
        public EmployeType EmpType
        {
            get { return _empType; }
            set
            {
                _empType = value;
                OnPropertyChanged("EmpType");
            }
        }

        ObservableCollection<Employee> _children;
        public ObservableCollection<Employee> Subordinates
        {
            get { return _children; }
            set
            {
                _children = value;
                OnPropertyChanged("Subordinates");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public enum EmployeType
    {
        Admin,
        Academic
    }
}
